Subject: Re: 2.6.25-rc8: WARNING: at net/ipv4/tcp_input.c:2173 tcp_mark_head_lost+0x11d/0x150()

From: Soeren Sonnenburg <[email-masked]>
Date: Sat, 05 Apr 2008 20:14:43 +0200

On Sat, 2008-04-05 at 20:52 +0300, Ilpo Järvinen wrote:
> On Sat, 5 Apr 2008, Soeren Sonnenburg wrote:
> 
> > On Fri, 2008-04-04 at 21:51 +0300, Ilpo Järvinen wrote:
> > > On Thu, 3 Apr 2008, Soeren Sonnenburg wrote:
> > > 
> > > > On Thu, 2008-04-03 at 16:26 +0300, Ilpo Järvinen wrote:
> > > > > On Thu, 3 Apr 2008, Soeren Sonnenburg wrote:
> > > > > 
> > > > > > trying to download things, I am seeing this (ignore the tainted, it is
> > > > > > from madwifi and although the module is loaded the device was never
> > > > > > used)
> > > > > > 
> > > > > > Could anyone make sense of this please?
[...]
> > > 
> > > Here's a debug patch which expensively verifies TCP's state in a number
> > > of places during ACK to find first spot where the actual bug occurs.
> > 
> > OK I am getting this now as the first spot:
> > 
> > P: 4 L: 2 vs 2 S: 0 vs 3 F: 0 vs 0 w: 4023500226-4023505874 (0)
> > skb 0 f495c180
> > skb 1 f480a180
> > skb 2 f4994600
> > head 3 f495c780
> > skb 4 f5b32480
> > TCP wq(s) LL  <
> > WARNING: at net/ipv4/tcp_ipv4.c:240 tcp_verify_wq+0x319/0x3c0()
> >
> > another one:
> > WARNING: at net/ipv4/tcp_output.c:1475 __tcp_push_pending_frames+0x70/0x830()
> > 
> > 
> > P: 4 L: 2 vs 2 S: 0 vs 3 F: 0 vs 0 w: 4023500226-4023505874 (0)
> > skb 0 f495c180
> > skb 1 f480a180
> > skb 2 f4994600
> > head 3 f495c780
> > skb 4 f5b32480
> > TCP wq(s) LL  <
> > TCP wq(h) +-++<
> > l2 s3 f0 p4 seq: su4023500226 hs241530103 sn4023505874
> > ------------[ cut here ]------------
> > WARNING: at net/ipv4/tcp_ipv4.c:240 tcp_verify_wq+0x319/0x3c0()
> 
> Please don't cut the log! It is caught here because 2+3 > 4 :-) but I need 
> the full log with stacktraces this time to figure it out.

Look here 
http://nn7.de/debugging/tcp.log :-)

HTH,
Soeren